package com.wluper.wluper_plugin_flutter.sdk.network
import io.reactivex.Single
import okhttp3.OkHttpClient
import retrofit2.Retrofit
import retrofit2.adapter.rxjava2.RxJava2CallAdapterFactory
import retrofit2.converter.gson.GsonConverterFactory
import retrofit2.http.Body
import retrofit2.http.POST
import retrofit2.http.Path

interface LOGApi {

    @POST("logging")
    fun logging(@Body body: com.wluper.wluper_plugin_flutter.sdk.models.WluperLog): Single<Any>

    companion object {
        var BASE_URL = "https://trueunderstanding.wluperapi.com"
        var URL_EXTENSION = "/v1/clients/"
        fun create(clientid:String,logapikey:String) : LOGApi {
            val httpClient = OkHttpClient.Builder()
            httpClient.addInterceptor { chain ->
                val original = chain.request()
                val requestBuilder = original.newBuilder()
                    .header("x-api-key", logapikey)
                val request = requestBuilder.build()
                chain.proceed(request)
            }
            val COMPLETE_BASE_URL = "$BASE_URL$URL_EXTENSION$clientid/"
            val retrofit = Retrofit.Builder()
                .baseUrl(COMPLETE_BASE_URL)
                .addConverterFactory(GsonConverterFactory.create())
                .addCallAdapterFactory(RxJava2CallAdapterFactory.create())
                .client(httpClient.build())
                .build()
            return retrofit.create(LOGApi::class.java)
        }
    }
}
