package com.wluper.wluper_plugin_flutter.sdk.utils

import android.util.Log
import com.wluper.wluper_plugin_flutter.sdk.models.WluperLog
import com.wluper.wluper_plugin_flutter.sdk.network.LOGApi
import com.wluper.wluper_plugin_flutter.sdk.network.TUApi
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.observers.DisposableSingleObserver
import io.reactivex.schedulers.Schedulers

class WluperLogManager(wluperLog:WluperLog, log_api:LOGApi) {
    var _wluperLog: WluperLog;
    var _log_api: LOGApi

    init {
        _wluperLog = wluperLog
        _log_api = log_api
    }

    fun post_event(event_name:String,event_value:String, session_id:String){
        _wluperLog.event_name = event_name;
        _wluperLog.event_value = event_value;
        _wluperLog.session_id = session_id;
        _wluperLog.timestamp = System.currentTimeMillis().toString();
        val call: DisposableSingleObserver<Any> = _log_api.logging(_wluperLog)
            .subscribeOn(Schedulers.io())
            .subscribeWith(object : DisposableSingleObserver<Any>(){
                override fun onSuccess(value: Any) {
                    Log.e("Log",value.toString())
                }
                override fun onError(e: Throwable) {
                    Log.e("Log",e.toString())
                }
            })
    }

}
