//
//  LOGApi.swift
//  test_wluper_sdk
//
//  Created by Alfonso Farruggia on 17/09/2021.
//

import Foundation
import UIKit


class LOGApi {
    var _logapikey:String
    var _clientid:String
    var base_url_logging = "https://trueunderstanding.wluperapi.com/v1/clients/"
    var endpoint_logging = "logging"

    init(clientid:String, logapikey:String) {
        _clientid = clientid
        _logapikey = logapikey
    }

    func create_request(base_url:String, endpoint:String, method:String)-> URLRequest {
        let url = URL(string: "\(base_url)\(_clientid)/\(endpoint)")!
        var request:URLRequest;
        request = URLRequest(url: url)
        request.httpMethod = method
        request.allHTTPHeaderFields = [ "x-api-key": _logapikey ]
        request.setValue("application/json", forHTTPHeaderField: "Accept")
        request.setValue("application/json", forHTTPHeaderField: "Content-Type")
        return request
    }

    public func logging(wluperLog:WluperLog){
        var request = create_request(base_url:base_url_logging, endpoint:endpoint_logging, method:"POST")
        let jsonData = try! JSONEncoder().encode(wluperLog)
        request.httpBody = jsonData
        let task = URLSession.shared.dataTask(with: request) { data, response, error in

            if let error = error {
                print("HTTP Request Failed \(error)")
            }
        }
        task.resume();
    }

}
